## condor 23.9.6+dfsg

=== CMakeLists.txt ===
 ###############################################################
 #
 # Copyright 2011 Red Hat, Inc.
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you
 # may not use this file except in compliance with the License.  You may
 # obtain a copy of the License at
 #
 #    http://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License
 #
 ###############################################################

##########################################################################
# Set project
cmake_minimum_required(VERSION 3.16)
project(CONDOR LANGUAGES C CXX)

# Exactly c++ 20 for all platforms
set(CMAKE_CXX_STANDARD 20) # when changing this, also change classad CMake
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Remove warnings in cmake 3.24+.  This setting 
# forces cmake to not update the timestamps on downloaded
# tarballs.  The autoconf-built externals need this old setting
if (${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.24)
  cmake_policy(SET CMP0135 OLD)
endif()
 
# generate a compile_commands.json file which tools
# like clang-tidy use
SET(CMAKE_EXPORT_COMPILE_COMMANDS YES)

##########################################################################
#Setup package meta-data (used in packaging)
set(PACKAGE "condor")

#Setup test package meta-data (used in packaging)
set(TEST_PACKAGE "condor_tests")
# Condor version info
#   Condor and other systems parse this number. Keep it simple:
#   Number.Number.Number. Do nothing else.  If you need to add
#   more information, PRE_RELEASE is usually the right location.
set(VERSION "23.9.6")

# Set PRE_RELEASE to either a string (i.e. "PRE-RELEASE-UWCS") or OFF
#   This should be "PRE-RELEASE-UWCS" most of the time, "DAILY" for
#   automated builds, "RC" for release candidates and OFF when
#   building a final release.  If you need to identify builds,
#   perhaps because you are working on a feature branch and need to
#   ship test binaries to a user, change this to identify your work.
#   Avoid whitespace.
#set(PRE_RELEASE "PRE-RELEASE-UWCS")
#set(PRE_RELEASE "RC")
set(PRE_RELEASE OFF)

# If set via the cmake command line, FORCE_PRE_RELEASE allows for
#   PRE_RELEASE to be forced into a build.
#   cmake ... -DFORCE_PRE_RELEASE:STRING=PRE-RELEASE-NMI
if( FORCE_PRE_RELEASE )
  set(PRE_RELEASE ${FORCE_PRE_RELEASE})
endif( FORCE_PRE_RELEASE )

set(PACKAGE_BUGREPORT "http://htcondor-wiki.cs.wisc.edu/index.cgi/tktnew")
set(PACKAGE_NAME ${PACKAGE} )
set(TEST_PACKAGE_NAME ${TEST_PACKAGE} )
set(PACKAGE_VERSION ${VERSION} )
set(PACKAGE_STRING ${PACKAGE} )
string( TOUPPER "${CMAKE_SYSTEM_NAME}" OS_NAME )
string( TOUPPER "${CMAKE_SYSTEM_VERSION}" OS_VER )
string( TOUPPER "${CMAKE_SYSTEM_PROCESSOR}" SYS_ARCH )

set(EMULATED_PLATFORM FALSE)
if( ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ppc64le" )
    set(EMULATED_PLATFORM TRUE)
endif()

site_name(HOSTNAME)
option(_DEBUG "Debug statements and set default build config" OFF)

###########################################
# start cmake module inclusion
list(APPEND CMAKE_MODULE_PATH ${CONDOR_SOURCE_DIR}/build/cmake/macros;${CONDOR_SOURCE_DIR}/build/cmake/modules;${CONDOR_SOURCE_DIR}/build/cmake)

include (dprint) # set debug module 1st to all spewing in other modules if needed
include (AppendVar)
include (CloneInstall)
include (FindMultiple)
include (FindSoName)
include (ExternalProject)
include (CheckIncludeFiles)
include (CheckIncludeFileCXX)
include (CheckFunctionExists)
include (CheckSymbolExists)
include (CheckStructHasMember)
include (CheckLibraryExists)
include (CheckTypeSize)
include (GetTimeDate)
include (CleanString)
include (SystemSpecificInformations)
include (CondorPackageConfig) # setup packaging variables needed prior to install targets
include (CondorSetLinkLibs)
include (CondorExe)
include (CondorDaemon)
include (CondorPrecompiledHeaders)
include (CondorStaticLib)
include (CondorPlugin)
include (CheckCCompilerFlag)
include (CheckCXXCompilerFlag)
include (CheckCXXSourceCompiles)
include (CTest)
include (CondorPLTest)
include (CondorExeTest)
include (CondorPreExternal)
include (CondorPostExternal)
include (CondorConfigure)     # will initiate the configure
include (TarGz) # Must be after include(CondorPackageConfig)

if ( WINDOWS )
	set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif ( WINDOWS )
##########################################################################
# we only include the single sub to allow make at two levels.
# root - includes externals
# src - src -> only
# this way clean @ root cleans externals while clean @src cleans just the src.
add_subdirectory (src)
add_subdirectory (build/packaging)
add_subdirectory (bindings/python)

##########################################################################
# the following are existing doc targets
# ideally one would transform the building of the docs to cmake or a script

# logic here to support old nmi builds
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/docs/_build/man")

	if (NOT WANT_MAN_PAGES OR "${SPHINXBUILD}" STREQUAL "SPHINXBUILD-NOTFOUND")
		message(STATUS "NOTE: Skipping man-pages")
	else()

		message(STATUS "NOTE: Will try building man-pages")
		# NOTE: deps are not configured to detect file changes.
		add_custom_command (OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/docs/_build/man/man1/condor_on.1
						COMMAND make
						ARGS SPHINXBUILD=${SPHINXBUILD} man
						WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs )

		add_custom_target ( docs ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/docs/_build/man/man1/condor_on.1 )

		install( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs/_build/man/ DESTINATION ${C_MAN} )
	endif()

else()
	message(STATUS "NOTE: Will install prebuilt man-pages")
	#Use trailing slash; otherwise, it will be C_MAN/man
	install( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs/_build/man/ DESTINATION ${C_MAN} )
endif()

##########################################################################
# Must in included post *install targets
include ( CPack )

=== docs/requirements.txt ===
sphinx-autodoc-typehints==1.12.0
nbsphinx==0.8.7
ipython==8.10.0
Jinja2>=3.0
htcondor>=23.1.0a0,<=23.999.999post999
Sphinx==5.3.0
sphinx-rtd-theme==1.0.0
sphinxcontrib-mermaid>=0.9.2
sphinx_copybutton>=0.5.0

=== src/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 


add_subdirectory(annex)
add_subdirectory(arc_gahp)
add_subdirectory(azure_gahp)
add_subdirectory(bash_completion.d)
add_subdirectory(blahp)
add_subdirectory(ccb)
add_subdirectory(condor_birdwatcher)
add_subdirectory(condor_c-gahp)
add_subdirectory(condor_chirp)
add_subdirectory(condor_collector.V6)
add_subdirectory(condor_credd)
add_subdirectory(condor_daemon_client)
add_subdirectory(condor_daemon_core.V6)
add_subdirectory(condor_dagman)
add_subdirectory(condor_examples)
add_subdirectory(condor_filetransfer_plugins)
add_subdirectory(condor_ft-gahp)
add_subdirectory(condor_gridmanager)
add_subdirectory(condor_had)
add_subdirectory(condor_io)
add_subdirectory(condor_job_router)
add_subdirectory(condor_kbdd)
add_subdirectory(condor_mail)
add_subdirectory(condor_master.V6)
add_subdirectory(condor_negotiator.V6)
add_subdirectory(condor_power)
add_subdirectory(condor_prio)
add_subdirectory(condor_procapi)
add_subdirectory(condor_procd)
add_subdirectory(condor_q.V6)
add_subdirectory(condor_release)
add_subdirectory(condor_rmdir)
add_subdirectory(condor_rm.V6)
add_subdirectory(condor_schedd.V6)
add_subdirectory(condor_scripts)
add_subdirectory(condor_shadow.V6.1)
add_subdirectory(condor_shared_port)
add_subdirectory(condor_startd.V6)
add_subdirectory(condor_starter.V6.1)
add_subdirectory(condor_status.V6)
add_subdirectory(condor_submit.V6)
add_subdirectory(condor_sysapi)
add_subdirectory(condor_tests)
add_subdirectory(condor_tools)
add_subdirectory(condor_unit_tests)
add_subdirectory(condor_userlog)
add_subdirectory(condor_utils)
add_subdirectory(condor_vm-gahp)
add_subdirectory(condor_who)
add_subdirectory(defrag)
add_subdirectory(ec2_gahp)
add_subdirectory(gangliad)
add_subdirectory(gce_gahp)
add_subdirectory(gpu)
add_subdirectory(openstack_gahp)
add_subdirectory(python-bindings)
add_subdirectory(rvgahp)

#if (BUILD_TESTING AND NOT WINDOWS)
if (BUILD_TESTING)
	if (WINDOWS)
		add_custom_target( BLD_TESTS )
		add_dependencies( BLD_TESTS ${CONDOR_TESTS} )
		#set(COPY_COMMAND xcopy /y)
		#set(COPY_RECURSIVE_COMMAND xcopy /ys)
	else(WINDOWS)
		add_custom_target(tests)
		add_dependencies(tests ${CONDOR_TESTS})
		#set(COPY_COMMAND cp)
		#set(COPY_RECURSIVE_COMMAND cp -r)
	endif(WINDOWS)

	# This is a bit ugly, but to make a package of tests, what we have to do is build a cmake script file
	# using FILE(WRITE/APPEND) commands that has inside it FILE(INSTALL) commands to build up the 
	# directory tree of tests and test dependencies that we want to package.
	#
	# we then define a custom target that invokes this cmake script file and then tars up the result
	#
	set(COPY_TESTS_CMAKE_FILE "${CMAKE_CURRENT_BINARY_DIR}/copy_tests.cmake")
	FILE(WRITE ${COPY_TESTS_CMAKE_FILE}
		"# generated cmake file to copy tests\n"
		"IF(NOT DEFINED CMAKE_INSTALL_PREFIX)\n"
		"  SET(CMAKE_INSTALL_PREFIX \"${CMAKE_BINARY_DIR}/release_dir\")\n"
	"ENDIF()\n"
	)
	if (WINDOWS)
		FILE(APPEND ${COPY_TESTS_CMAKE_FILE}
			"IF(NOT DEFINED BUILD_TYPE)\n"
			"  SET(BUILD_TYPE RelWithDebInfo)\n"
			"ENDIF()\n"
		)
	endif(WINDOWS)

	# recursive copy the condor_tests source directory
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "FILE(INSTALL \"${CMAKE_CURRENT_SOURCE_DIR}/condor_tests\" DESTINATION \${CMAKE_INSTALL_PREFIX})\n")

	# setup a big copy list for the tests themselves
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "FILE(INSTALL " "DESTINATION \${CMAKE_INSTALL_PREFIX}/condor_tests TYPE EXECUTABLE FILES\n")
	# 
	FOREACH (test IN LISTS CONDOR_TEST_EXES)
		if (WINDOWS)
			FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_BINARY_DIR}/condor_tests/\${BUILD_TYPE}/${test}\"\n")
		else (WINDOWS)
			FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_BINARY_DIR}/condor_tests/${test}\" \n")
		endif(WINDOWS)
	ENDFOREACH (test)
	# copy rules for pl tests
	FOREACH (test IN LISTS CONDOR_PL_TESTS)
		IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/condor_tests/${test}.run)
			FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_SOURCE_DIR}/condor_tests/${test}.run\" \n")
		ELSEIF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/condor_tests/${test}.py)
			FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_SOURCE_DIR}/condor_tests/${test}.py\" \n")
		ELSE()
			# hack to trigger the same "cannot find file" as would appear with no .py check
			FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_SOURCE_DIR}/condor_tests/${test}.run\" \n")
		ENDIF()
	ENDFOREACH (test)
	# copy rules for tests helper scripts
	FOREACH (script IN LISTS CONDOR_TEST_HELPER_SCRIPTS)
		FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_SOURCE_DIR}/condor_scripts/${script}\" \n")
	ENDFOREACH (script)
	# close the big copy list
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_SOURCE_DIR}/msconfig/do_tests.pl\" \n")
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} ")\n")

	# copy the generated test lists
	APPEND_UNIQUE_VAR(CONDOR_TEST_LIST_TAGS "all")
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "FILE(INSTALL " "DESTINATION \${CMAKE_INSTALL_PREFIX}/condor_tests TYPE FILE FILES\n")
	#FOREACH (tag "quick" "all" "ckpt" "core" "condorc" "critical" "dagman" "filexfer" "framework" "full" "java" "lib" "local" "long" "rsc" "simple" "stduniv" "time")
	FOREACH (tag IN LISTS CONDOR_TEST_LIST_TAGS)
		FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${TEST_TARGET_DIR}/list_${tag}\"\n")
	ENDFOREACH(tag)
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} "  \"${CMAKE_CURRENT_BINARY_DIR}/condor_utils/param_info_tables.h\"\n")
	FILE(APPEND ${COPY_TESTS_CMAKE_FILE} ")\n")

	IF(WINDOWS)
		FILE(TO_NATIVE_PATH "${COPY_TESTS_CMAKE_FILE}" WIN_COPY_TESTS_FILE)
		add_custom_target(tests-tar-pkg
			DEPENDS BLD_TESTS
			COMMAND ${CMAKE_COMMAND} -DBUILD_TYPE=$(Configuration) -DCMAKE_INSTALL_PREFIX=${CPACK_TEST_PACKAGE_FILE_NAME} -P "${WIN_COPY_TESTS_FILE}"
		)
	ELSE(WINDOWS)
		add_custom_target(tests-tar-pkg
			DEPENDS tests
			COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CPACK_TEST_PACKAGE_FILE_NAME} -P ${COPY_TESTS_CMAKE_FILE}
		)
	ENDIF(WINDOWS)

	add_custom_command(
	    TARGET tests-tar-pkg
	    POST_BUILD
	    COMMAND ${CMAKE_COMMAND} -E tar czf ${CPACK_TEST_PACKAGE_FILE_NAME}.tar.gz ${CPACK_TEST_PACKAGE_FILE_NAME}
	    COMMAND ${CMAKE_COMMAND} -E copy ${CPACK_TEST_PACKAGE_FILE_NAME}.tar.gz ${CMAKE_BINARY_DIR}
	    COMMAND ${CMAKE_COMMAND} -E remove -f ${CPACK_TEST_PACKAGE_FILE_NAME}.tar.gz
	    COMMAND ${CMAKE_COMMAND} -E remove_directory ${CPACK_TEST_PACKAGE_FILE_NAME}
	)

	dprint("CONDOR_TEST_LIST_TAGS=${CONDOR_TEST_LIST_TAGS}")
	dprint("CONDOR_TESTS=${CONDOR_TESTS}")
endif()

install ( FILES condor_includes/file_lock.h
		DESTINATION ${C_INCLUDE})

=== bindings/python/CMakeLists.txt ===

# These are expanded in setup.py.cmake_template
set(PACKAGES      "classad3" "classad2" "classad" "htcondor2" "htcondor" "htcondor/dags" "htcondor/htchirp" "htcondor/_utils")

# The python sources to copy
set(PYTHON_SOURCES
htcondor/_wrap.py
htcondor/__init__.py
htcondor/_lock.py
htcondor/personal.py
htcondor/htchirp/__init__.py
htcondor/htchirp/htchirp.py
htcondor/dags/writer.py
htcondor/dags/exceptions.py
htcondor/dags/__init__.py
htcondor/dags/formatter.py
htcondor/dags/dag.py
htcondor/dags/walk_order.py
htcondor/dags/edges.py
htcondor/dags/utils.py
htcondor/dags/rescue.py
htcondor/dags/node.py
htcondor/_deprecation.py
htcondor/_job_status.py

classad/__init__.py

# Private python utilities
htcondor/_utils/__init__.py
htcondor/_utils/ansi.py

# Version 2.
htcondor2/_negotiator.py
htcondor2/_collector.py
htcondor2/_startd.py
htcondor2/_credd.py
htcondor2/_cred_check.py
htcondor2/_cred_type.py
htcondor2/_subsystem_type.py
htcondor2/_daemon_type.py
htcondor2/_ad_type.py
htcondor2/_daemon_command.py
htcondor2/_drain_type.py
htcondor2/_completion_type.py
htcondor2/_common_imports.py
htcondor2/_schedd.py
htcondor2/_query_opt.py
htcondor2/_job_action.py
htcondor2/_transaction_flag.py
htcondor2/_submit.py
htcondor2/_submit_method.py
htcondor2/_submit_result.py
htcondor2/_job_event.py
htcondor2/_job_event_log.py
htcondor2/_job_event_type.py
htcondor2/_job_status.py
htcondor2/_param.py
htcondor2/_remote_param.py
htcondor2/_file_transfer_event_type.py
htcondor2/_logging.py
htcondor2/_log_level.py
htcondor2/_loose_functions.py
htcondor2/__init__.py

classad2/__init__.py
classad2/_class_ad.py
classad2/_value.py
classad2/_expr_tree.py
classad2/_parser_type.py

# Version 3
classad3/__init__.py
classad3/ClassAd.py
classad3/Expression.py

)

set(SETUP_PY_IN   "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.cmake_template")
set(SETUP_PY      "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
set(INSTALL_SH    "${CMAKE_CURRENT_SOURCE_DIR}/install.sh")

if (WITH_PYTHON_BINDINGS)
    set(DEPS "")

    configure_file(${SETUP_PY_IN} ${SETUP_PY})

	# Make the target directories for python source tree
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/htcondor)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/htcondor2)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/htcondor/dags)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/htcondor/htchirp)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/htcondor/_utils)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classad)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classad2)
	file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classad3)

	# Now make a command to copy each source file to the destination
	foreach(PYTHON_SOURCE_FILE ${PYTHON_SOURCES})
		add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_SOURCE_FILE}"
			COMMAND ${CMAKE_COMMAND} ARGS -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${PYTHON_SOURCE_FILE}" "${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_SOURCE_FILE}"
			DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${PYTHON_SOURCE_FILE}"
    )
	list(APPEND DEPS "${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_SOURCE_FILE}")
    endforeach()

    if (WINDOWS AND DEFINED PYTHON_VERSION_STRING)
        list(APPEND DEPS classad_module htcondor)
    endif()

    if (WINDOWS AND DEFINED PYTHON3_VERSION_STRING)
        list(APPEND DEPS py3classad_module py3htcondor)
        if (NOT DEFINED PYTHON_VERSION_STRING) # make sure Windows has a Python executable even if building Python 3 only
            set(PYTHON_EXECUTABLE ${PYTHON3_EXECUTABLE})
        endif()
    endif()

    if (PYTHONLIBS_FOUND OR (WINDOWS AND PYTHON3LIBS_FOUND))
        set(TIMESTAMP_FILE "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp")
        if (WINDOWS) # build scaffolding for both Python 2 and 3 on Windows
            add_custom_command(
                OUTPUT ${TIMESTAMP_FILE}
                COMMAND "${PYTHON_EXECUTABLE}" ${SETUP_PY} build
                COMMAND ${CMAKE_COMMAND} ARGS -E touch ${TIMESTAMP_FILE}
                DEPENDS ${DEPS}
            )
        else() # build scaffolding for Python 2 only on non-Windows
            add_custom_command(
                OUTPUT ${TIMESTAMP_FILE}
                COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} build
        	    COMMAND ${CMAKE_COMMAND} ARGS -E touch ${TIMESTAMP_FILE}
                DEPENDS ${DEPS} classad_module htcondor
            )
        endif()
        add_custom_target(python_bindings ALL DEPENDS ${TIMESTAMP_FILE})

        if (WINDOWS) # Windows can call setup.py as normal
            install(CODE "execute_process(
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                COMMAND \"${PYTHON_EXECUTABLE}\" ${SETUP_PY} install --root=${CMAKE_INSTALL_PREFIX} --install-lib=${C_PYTHONARCHLIB}
                ERROR_VARIABLE _err
                RESULT_VARIABLE _ret)
                if (NOT \${_ret} EQUAL \"0\")
                    message( FATAL_ERROR \"\${_err}\" )
                endif()
            ")
        else() # non-Windows should call a script that invokes setup.py
            install(CODE "execute_process(
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                COMMAND ${INSTALL_SH} ${PYTHON_EXECUTABLE} ${SETUP_PY} ${CMAKE_INSTALL_PREFIX} ${C_PYTHONARCHLIB}
                ERROR_VARIABLE _err
                RESULT_VARIABLE _ret)
                if (NOT \${_ret} EQUAL \"0\")
                    message( FATAL_ERROR \"\${_err}\" )
                endif()
            ")
        endif()
    endif()

    # build Python 3 scaffolding on non-Windows
    if (DARWIN)
        # This is probably a sign that something else needs fixing.
        # Note that value shoud NOT be the same as the variable name.
        set(SYSTEM_NAME "darwin")
    endif()

    if (NOT WINDOWS AND PYTHON3LIBS_FOUND)
        set(TIMESTAMP3_FILE "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp3")
        add_custom_command(
            OUTPUT ${TIMESTAMP3_FILE}
            COMMAND ${PYTHON3_EXECUTABLE} ${SETUP_PY} build
            COMMAND ${CMAKE_COMMAND} ARGS -E touch ${TIMESTAMP3_FILE}
            DEPENDS ${DEPS} py3classad_module py3htcondor py3classad3_impl py3htcondor2_impl py3classad2_impl
        )

        add_custom_target(python3_bindings ALL DEPENDS ${TIMESTAMP3_FILE})
        install(CODE "execute_process(
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                COMMAND ${INSTALL_SH} ${PYTHON3_EXECUTABLE} ${SETUP_PY} ${CMAKE_INSTALL_PREFIX} ${C_PYTHON3ARCHLIB}
                ERROR_VARIABLE _err
                RESULT_VARIABLE _ret)
                if (NOT \${_ret} EQUAL \"0\")
                    message( FATAL_ERROR \"\${_err}\" )
                endif()
        ")
    endif()

endif()

if (NOT WINDOWS AND WANT_PYTHON_WHEELS)
    add_custom_target(bdist_wheel ALL DEPENDS python_bindings wheel_classad_module wheel_htcondor COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} bdist_wheel)
endif()

=== src/arc_gahp/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright (C) 1990-2021, Condor Team, Computer Sciences Department,
 # University of Wisconsin-Madison, WI.
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

if( NOT WINDOWS )

	include_directories(${CMAKE_CURRENT_SOURCE_DIR})
	include_directories(${CMAKE_CURRENT_BINARY_DIR})

	set(SourceFiles
		arcCommands.cpp
		arcgahp_common.cpp
		io_loop_pthread.cpp
		PipeBuffer.cpp
	)

	condor_exe( arc_gahp
		"${SourceFiles}" ${C_SBIN}
		"${CONDOR_TOOL_LIBS};${CURL_FOUND}"
		OFF )

endif()

=== src/bash_completion.d/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2016, University of Nebraska-Lincoln
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

if (NOT WINDOWS)

  install(FILES          condor
                         DESTINATION     "etc/bash_completion.d/"
         )

endif(NOT WINDOWS)

=== src/blahp/CMakeLists.txt ===
# ****************
# * BLAHP daemon * 
# ****************
#
# $Id: $ 
#
# File:           CMakeLists.txt
#
# Author(s):      Francesco Prelz ($Author: $)
#        e-mail: "Francesco.Prelz@mi.infn.it"
#
# Revision history:
#
# 5-Nov-2012  Created 

if (NOT CONDOR_PACKAGE_NAME)

    cmake_minimum_required(VERSION 3.16)

    project(glite-ce-blahp)
    project(BLAH)

    # CPack info

    set(CPACK_RPM_PACKAGE_RELEASE "0")

    if (UNIX AND NOT APPLE)
    set(CPACK_GENERATOR "STGZ;DEB;RPM")
    execute_process(COMMAND uname -i 
        OUTPUT_VARIABLE local_arch OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(CPACK_SYSTEM_NAME "${CPACK_RPM_PACKAGE_RELEASE}.${local_arch}")
    endif (UNIX AND NOT APPLE)

    set(CMAKE_INSTALL_PREFIX "/usr")

    set(CPACK_PACKAGE_NAME "BLAH")
    set(CPACK_PACKAGE_VENDOR "EMI")
    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Batch Local ASCII Helper Protocol suite")
    set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/blah_description.txt")
    set(CPACK_PACKAGE_VERSION_MAJOR "2")
    set(CPACK_PACKAGE_VERSION_MINOR "2")
    set(CPACK_PACKAGE_VERSION_PATCH "0")
    set(CPACK_PACKAGE_VERSION 
       "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

    # For the following setting, see CMAKE manual, page 155
    # or http://public.kitware.com/Bug/view.php?id=7000
    set(CPACK_SET_DESTDIR ON)
    set(CPACK_PACKAGE_RELOCATABLE "false")

    set(CPACK_PACKAGE_CONTACT "blah@mi.infn.it")
    set(CPACK_RPM_PACKAGE_LICENSE "Apache Software License")
    set(CPACK_RPM_PACKAGE_GROUP "Applications/Internet")

    set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE 
        ${CMAKE_CURRENT_SOURCE_DIR}/project/glite-ce-blahp.post)
    set(CPACK_RPM_PRE_UNINSTALL_SCRIPT_FILE 
        ${CMAKE_CURRENT_SOURCE_DIR}/project/glite-ce-blahp.preun)

    install(FILES LICENSE 
        DESTINATION share/doc/BLAH-2.2.0)

endif(NOT CONDOR_PACKAGE_NAME)

if (NOT CONDOR_PACKAGE_NAME OR WITH_BLAHP)
    add_subdirectory(src build)
    add_subdirectory(config)
    add_subdirectory(doc)
endif(NOT CONDOR_PACKAGE_NAME OR WITH_BLAHP)

=== src/condor_daemon_client/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

set (DAEMON_CLIENT_UTIL_SRCS
${CMAKE_CURRENT_SOURCE_DIR}/daemon.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_annexd.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_message.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_shadow.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_transfer_queue.cpp
${CMAKE_CURRENT_SOURCE_DIR}/daemon_list.cpp
${CMAKE_CURRENT_SOURCE_DIR}/daemon_types.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_collector.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_master.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_schedd.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_startd.cpp
${CMAKE_CURRENT_SOURCE_DIR}/dc_starter.cpp
PARENT_SCOPE
)

=== src/condor_daemon_core.V6/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

# These are all referenced in condor_utils, we we need absolute paths
set(DAEMON_CORE_UTIL_SRCS_LOCAL
${CMAKE_CURRENT_SOURCE_DIR}/condor_lock_base.cpp
${CMAKE_CURRENT_SOURCE_DIR}/condor_lock.cpp
${CMAKE_CURRENT_SOURCE_DIR}/condor_lock_file.cpp
${CMAKE_CURRENT_SOURCE_DIR}/condor_lock_implementation.cpp
${CMAKE_CURRENT_SOURCE_DIR}/daemon_command.cpp
${CMAKE_CURRENT_SOURCE_DIR}/daemon_core.cpp
${CMAKE_CURRENT_SOURCE_DIR}/daemon_core_main.cpp
${CMAKE_CURRENT_SOURCE_DIR}/daemon_keep_alive.cpp
${CMAKE_CURRENT_SOURCE_DIR}/datathread.cpp
${CMAKE_CURRENT_SOURCE_DIR}/HookClient.cpp
${CMAKE_CURRENT_SOURCE_DIR}/HookClientMgr.cpp
${CMAKE_CURRENT_SOURCE_DIR}/self_draining_queue.cpp
${CMAKE_CURRENT_SOURCE_DIR}/self_monitor.cpp
${CMAKE_CURRENT_SOURCE_DIR}/timer_manager.cpp
)

# List APPEND only appends to a local scoped variable
if(WINDOWS)
list(APPEND DAEMON_CORE_UTIL_SRCS_LOCAL
${CMAKE_CURRENT_SOURCE_DIR}/exception_handling.WINDOWS.cpp
${CMAKE_CURRENT_SOURCE_DIR}/pipe.WINDOWS.cpp
)
endif()

# and propogate this variable up to the parent scope
set(DAEMON_CORE_UTIL_SRCS 
	${DAEMON_CORE_UTIL_SRCS_LOCAL}
	PARENT_SCOPE
)

if (WINDOWS)
	condor_exe( condor_softkill "condor_softkill.WINDOWS.cpp;condor_softkill.h" ${C_SBIN} "${CONDOR_TOOL_LIBS};psapi" OFF )
	set_target_properties (condor_softkill PROPERTIES WIN32_EXECUTABLE TRUE)
endif(WINDOWS)

=== src/condor_dagman/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

set(DAGSrcs 
dag.cpp
dagman_classad.cpp
dagman_commands.cpp
dagman_main.cpp
dagman_metrics.cpp
dagman_stats.cpp
dagman_submit.cpp
debug.cpp
job.cpp
jobstate_log.cpp
parse.cpp
script.cpp
scriptQ.cpp
throttle_by_category.cpp
)

condor_exe(condor_dagman "${DAGSrcs}" ${C_BIN} "${CONDOR_LIBS}" ON)

condor_exe(condor_submit_dag "condor_submit_dag.cpp" ${C_BIN} "${CONDOR_TOOL_LIBS}" OFF)

=== src/condor_examples/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

if (NOT WINDOWS)

install(FILES		condor-annex-ec2
		DESTINATION	"${C_ETC_EXAMPLES}"
		PERMISSIONS ${CONDOR_SCRIPT_PERMS}
)

# Only install the master shutdown script on RHEL for now
if (RPM_SYSTEM_NAME)
install(FILES		master_shutdown_script.sh
		DESTINATION	"${C_CONFIGD}/.."
		PERMISSIONS	${CONDOR_SCRIPT_PERMS}
)
endif (RPM_SYSTEM_NAME)

# Only install the small shadow configuration on RHEL
if (RPM_SYSTEM_NAME AND (${BIT_MODE} MATCHES "32"))
install(FILES		00-small-shadow
		DESTINATION	"${C_ETC_EXAMPLES}"
)
endif ()


install (FILES
		condor.boot.generic
		condor_config.local.central.manager
		condor_config.local.ha_condor_client
		README
		condor.boot.rpm
		condor_config.local.ha_condor_had
		condor_config.generic
		condor_config.tarball
		condor_config.local.dedicated.resource
		condor_config.local.view_server
		#condor_config.generic.debian.patch
		condor_config.local.dedicated.submit
		condor_config.submit.generic
		#condor_config.generic.rpm.patch
		#condor_config.local.generic
		condor_config.local.adstash
		condor.init
		condor.plist
		condor_config.annotated
		condor.service
		condor.socket
		condor-tmpfiles.conf
		condor-annex-ec2.service
		00-minicondor
		00-access-point
		00-htcondor-9.0.config
		00-kbdd
		50-security
		50ec2.config
		DESTINATION ${C_ETC_EXAMPLES})

install (FILES
	  openmpiscript
	  mp2script
	  mp1script
	 DESTINATION ${C_ETC_EXAMPLES}
	 PERMISSIONS ${CONDOR_SCRIPT_PERMS} )

install (FILES 
	condor_limits_wrapper.sh
	condor_schedd.init
	DESTINATION ${C_LIBEXEC}
	PERMISSIONS ${CONDOR_SCRIPT_PERMS})

# This one shouldn't have execute bits set
install (FILES 
	interactive.sub
	DESTINATION ${C_LIBEXEC})

#Prepare OS specific config file

if ( RPM_SYSTEM_NAME AND CONDOR_PACKAGE_BUILD)

	add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
					WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
					COMMAND cp 
					ARGS ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic condor_config.patched
					COMMAND patch 
					ARGS condor_config.patched ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic.rpm.patch )

	add_custom_target(	patch_configurations
					ALL
					DEPENDS condor_config.patched)
	install(FILES		${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
			DESTINATION	"${C_ETC}"
			RENAME	condor_config)

elseif ( DEB_SYSTEM_NAME AND CONDOR_PACKAGE_BUILD)

	add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						COMMAND cp
						ARGS ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic condor_config.patched
					    COMMAND patch
						ARGS condor_config.patched ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic.debian.patch )

	add_custom_target(	patch_configurations
						ALL
						DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched)

	install(FILES		${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						DESTINATION	"${C_ETC}"
						RENAME	condor_config)

elseif( APPLE )

	install(FILES         condor_config.tarball
	        DESTINATION   "${C_ETC}"
	        RENAME        condor_config)

else()
	#Other Platform
	install(FILES		condor_config.generic
			DESTINATION	"${C_ETC}"
			RENAME	condor_config)

	install(FILES		condor.boot.rpm
			DESTINATION	"${C_INIT}"
			PERMISSIONS ${CONDOR_SCRIPT_PERMS}
			RENAME		condor)

endif()
else()
	install(FILES		condor_config.windows.base
			DESTINATION	"${C_ETC}"
			RENAME	condor_config.base)

	install(FILES
	        condor_config.power
	        condor_config.submit.generic
	        condor_config.local.blank
	        condor_config.local.generic
	        condor_config.local.credd 
	        condor_config.local.central.manager
	        convert_config_to_win32.awk
			DESTINATION	"${C_ETC}")


endif(NOT WINDOWS)

=== src/condor_had/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

set(HADSrcs
	StateMachine.cpp
	HAD.cpp
	Utils.cpp
)

condor_exe(condor_had "${HADSrcs}" ${C_SBIN} "${CONDOR_LIBS}" ON)

set(RepSrcs
	AbstractReplicatorStateMachine.cpp
	ReplicatorStateMachine.cpp
	HAD_Version.cpp
	Utils.cpp
	Replication.cpp
	FilesOperations.cpp
)

condor_exe(condor_replication "${RepSrcs}" ${C_SBIN} "${CONDOR_LIBS}" OFF)

set(TransferSrcs
	BaseReplicaTransferer.cpp
	UploadReplicaTransferer.cpp
	DownloadReplicaTransferer.cpp
	Utils.cpp
	Transferer.cpp
	FilesOperations.cpp
)

condor_exe(condor_transferer "${TransferSrcs}" ${C_LIBEXEC} "${CONDOR_LIBS}" OFF)

=== debian/changelog ===
condor (23.9.6+dfsg-2.1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:13:38 +0200

condor (23.9.6+dfsg-2.1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:03:14 +0200

condor (23.9.6+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add missing Built-Using to the condor binary package (Closes: #1106798).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 20 Jun 2025 21:49:07 +0200

condor (23.9.6+dfsg-2) unstable; urgency=medium

  * Address security issue CVE-2025-30093 (Closes: #1101498)

 -- Tim Theisen <tim@cs.wisc.edu>  Wed, 02 Apr 2025 16:50:00 -0500

condor (23.9.6+dfsg-1) unstable; urgency=medium

  * Add config knob to not have cgroups count kernel memory with cgroups v2
  * Remove support for numeric unit suffixes (k,M,G) in ClassAd expressions
  * In submit files, request_disk & request_memory still accept unit suffixes
  * Hide GPUs not allocated to the job on cgroup v2 systems
  * DAGMan can now produce credentials when using direct submission
  * Singularity jobs have a contained home directory when file transfer is on
  * Avoid using IPv6 link local addresses when resolving hostname to IP addr
  * New 'htcondor credential' command to aid in debugging
  * Add new condor-ap package to facilitate Access Point installation
  * The user can now choose which submit method DAGMan will use
  * Can add custom attributes to the User ClassAd with condor_qusers -edit
  * Add use-projection option to condor_gangliad to reduce memory footprint
  * Fix bug where interactive submit does not work on cgroup v2 systems
  * Warns about deprecated multiple queue statements in a submit file
  * The semantics of 'skip_if_dataflow' have been improved
  * Removing large DAGs is now non-blocking, preserving schedd performance
  * Periodic policy expressions are now checked during input file transfer
  * Local universe jobs can now specify a container image
  * File transfer plugins can now advertise extra attributes
  * DAGMan can rescue and abort if pending jobs are missing from the job queue
  * Docker and Container jobs run on EPs that match AP's CPU architecture
  * Fixed premature cleanup of credentials by the condor_credd
  * Fixed bug where a malformed SciToken could cause a condor_schedd crash
  * Fixed crash in condor_annex script
  * Fixed daemon crash after IDTOKEN request is approved by the collector
  * Remote condor_history queries now work the same as local queries
  * Improve error handling when submitting to a remote scheduler via ssh
  * Fix Python binding crash when submitting a DAG which has empty lines
  * Warns about deprecated multiple queue statements in a submit file
  * Fix bug where plugins could not signify to retry a file transfer
  * The condor_upgrade_check script checks for proper token file permissions

 -- Tim Theisen <tim@cs.wisc.edu>  Fri, 28 Mar 2025 15:09:00 -0500

=== debian/control ===
Source: condor
Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
Uploaders: Tim Theisen <tim@cs.wisc.edu>
Section: science
Priority: optional
Build-Depends: cmake (>= 3.16),
               debhelper,
               debhelper-compat (= 13),
               default-jdk,
               dh-python,
               dh-sequence-builtusing,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libcgroup-dev,
               libcurl4-openssl-dev,
               libkrb5-dev,
               libldap2-dev | libldap-dev,
               libmunge-dev,
               libpam0g-dev,
               libpcre2-dev,
               libpq-dev,
               libscitokens-dev,
               libssl-dev,
               libsqlite3-dev,
               libsystemd-dev,
               libvirt-dev,
               libx11-dev,
               libxml2-dev,
               libxss-dev,
               python3-dev,
               python3-setuptools,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               python3-nbsphinx,
               python3-sphinx-autodoc-typehints,
               uuid-dev,
               voms-dev,
               zlib1g-dev
Build-Conflicts: liblog4cpp5-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/hpc-team/condor
Vcs-Git: git://salsa.debian.org/hpc-team/condor.git
Homepage: https://htcondor.org/
Rules-Requires-Root: no

Package: condor
Architecture: any
Depends: adduser,
         libdate-manip-perl,
         python3,
         python3-cryptography,
         python3-requests,
         libcom-err2,
         libgssapi-krb5-2,
         libk5crypto3,
         libkrb5-3,
         libkrb5support0,
         libmunge2,
         net-tools,
         libjs-bootstrap,
         libjs-jquery,
         ${lib:Depends},
         condor-upgrade-checks,
         ${misc:Depends},
         ${perl:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: bash-completion,
            openssh-server
Suggests: docker.io,
          coop-computing-tools,
          singularity-container,
          slurm-client
Conflicts: htcondor (<< ${binary:Version}),
           libclassad16
Breaks: htcondor (<< ${binary:Version}),
        libclassad16
Replaces: htcondor (<< ${binary:Version}),
          libclassad16
Built-Using: ${dh-builtusing:libc-dev-bin} [!amd64]
Description: distributed workload management system
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package can set up an appropriate initial configuration at install
 time for a machine intended either as a member of an existing HTCondor pool
 or as a "Personal" (single machine) HTCondor pool.

Package: condor-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: htcondor-dev (<< ${binary:Version}),
           libclassad-dev
Breaks: htcondor-dev (<< ${binary:Version}),
        libclassad-dev
Replaces: htcondor-dev (<< ${binary:Version}),
          libclassad-dev
Description: distributed workload management system - development files
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides headers and libraries for development of HTCondor
 add-ons.

Package: condor-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Conflicts: htcondor-doc (<< ${binary:Version})
Breaks: htcondor-doc (<< ${binary:Version})
Replaces: htcondor-doc (<< ${binary:Version})
Description: distributed workload management system - documentation
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides HTCondor's documentation in HTML and PDF format, as well
 as configuration and other examples.

Package: minicondor
Architecture: any
Section: science
Depends: condor (= ${binary:Version}),
         ${misc:Depends}
Conflicts: minihtcondor (<< ${binary:Version})
Breaks: minihtcondor (<< ${binary:Version})
Replaces: minihtcondor (<< ${binary:Version})
Description: distributed workload management system - single node configuration
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides an example configuration is good for trying out HTCondor
 for the first time. It only configures the IPv4 loopback address, turns on
 basic security, and shortens many timers to be more responsive.

Package: condor-annex-ec2
Architecture: any
Section: science
Depends: condor (= ${binary:Version}),
         ${misc:Depends}
Conflicts: htcondor-annex-ec2 (<< ${binary:Version})
Breaks: htcondor-annex-ec2 (<< ${binary:Version})
Replaces: htcondor-annex-ec2 (<< ${binary:Version})
Description: distributed workload management system - single node configuration
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides configuration and script to make an EC2 image
 annex-compatible.  Do NOT install on a non-EC2 image.

Package: condor-upgrade-checks
Architecture: all
Section: science
Depends: python3,
         pcre2-utils,
         ${misc:Depends}
Conflicts: htcondor-upgrade-checks (<< ${binary:Version})
Breaks: htcondor-upgrade-checks (<< ${binary:Version})
Replaces: htcondor-upgrade-checks (<< ${binary:Version})
Description: distributed workload management system - single node configuration
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 Examines the current HTCondor installation and recommends changes to ensure
 a smooth upgrade to a subsequent HTCondor version.


Package: condor-kbdd
Architecture: any
Section: science
Depends: condor (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: distributed workload management system - single node configuration
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 The condor_kbdd monitors logged in X users for activity. It is only
 useful on systems where no device (e.g. /dev/*) can be used to
 determine console idle time.


Package: condor-vm-gahp
Architecture: any
Section: science
Depends: condor (= ${binary:Version}),
         libvirt0,
         ${misc:Depends},
         ${shlibs:Depends}
Description: distributed workload management system - single node configuration
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 The condor_vm-gahp enables the Virtual Machine Universe feature of
 HTCondor. The VM Universe uses libvirt to start and control VMs under
 HTCondor's Startd.

Package: condor-test
Architecture: any
Section: science

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )

# if this package is built in an i386 build environment on an amd64 host,
# a toolchain file is required so cmake uses the right CMAKE_SYSTEM_PROCESSOR
CMAKE_SYSTEM_PROCESSOR = $(shell  cmake --system-information | grep CMAKE_SYSTEM_PROCESSOR | cut -d'"' -f2)
DEB_TARGET_ARCH = $(shell dpkg --print-architecture)
export CMAKE_TOOLCHAIN := ""
ifeq ($(DEB_TARGET_ARCH), i386)
ifeq ($(CMAKE_SYSTEM_PROCESSOR), x86_64)
    export CMAKE_TOOLCHAIN := "-DCMAKE_TOOLCHAIN_FILE=$(CURDIR)/debian/i386-toolchain.cmake"
endif
endif

%:
	dh $@ --with python3


override_dh_auto_configure:
	dh_auto_configure -- \
		$(CMAKE_TOOLCHAIN) \
		-DPACKAGEID:STRING="$(debver)"\
		-DBUILD_TESTING:BOOL=ON \
		-DCMAKE_SKIP_RPATH:BOOL=ON \
		-DCONDOR_PACKAGE_BUILD:BOOL=ON \
		-DCMAKE_INSTALL_PREFIX:PATH=/


override_dh_auto_build: docs/build
	dh_auto_build --parallel
	# post-fixing things that have to be done due to changes introduced by
	# repackaging
	# 1. rebuild java stuff
	cd src/condor_starter.V6.1 && javac *.java
	cp src/condor_chirp/*.java src/condor_chirp/chirp/java/client/
	$(MAKE) -C src/condor_chirp/chirp/java/client/
	cp src/condor_chirp/chirp/java/client/Chirp.jar src/condor_chirp/


override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/tmp/usr/lib/ -l$(CURDIR)/debian/tmp/usr/lib/condor --dpkg-shlibdeps-params=--ignore-missing-info


docs/build:
	mkdir -p $@
	$(MAKE) -C docs man
	mkdir -p $@/man
	mv docs/_build/man/* $@/man


override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/etc/rc.d
	# Remove tarball files that we do not use
	rm -f debian/tmp/usr/bin/make-ap-from-tarball
	rm -f debian/tmp/usr/bin/make-personal-from-tarball
	rm -f debian/tmp/usr/sbin/condor_configure
	rm -f debian/tmp/usr/sbin/condor_install
	# create blahp files
	mkdir --mode 0755 debian/tmp/etc/blahp
	for batch_system in condor kubernetes lsf nqs pbs sge slurm; do \
		mv debian/tmp/usr/libexec/blahp/$${batch_system}_local_submit_attributes.sh debian/tmp/etc/blahp/; \
		ln -s ../../../etc/blahp/$${batch_system}_local_submit_attributes.sh \
			debian/tmp/usr/libexec/blahp/$${batch_system}_local_submit_attributes.sh; \
	done
	# Remove extranenous files
	rm debian/tmp/usr/share/doc/condor/LICENSE
	rm debian/tmp/usr/share/doc/condor/README
	# This isn't ready for release yet.
	rm -fr debian/tmp/usr/lib/python3/dist-packages/classad3
	# Temporarily remove sif file until apptainer is fully supported
	rm -f debian/tmp/usr/libexec/condor/exit_37.sif


override_dh_fixperms-arch:
	dh_fixperms
	chmod a-x debian/condor/usr/libexec/condor/interactive.sub
	chmod a-x debian/condor/usr/libexec/condor/ce-audit.so
	chmod a-x debian/condor/usr/libexec/condor/libclassad_python_user.*.so


override_dh_install-arch:
	dh_install
	# fix permissions
	# remove duplicate that is also installed as a config file
	rm -f debian/condor/usr/libexec/condor/linux-kernel-tuning
	# move etc/bash_completion.d/ to usr/share/bash-completion/completions
	mkdir -p debian/condor/usr/share/bash-completion/completions
	mv debian/condor/etc/bash_completion.d/* debian/condor/usr/share/bash-completion/completions
	rmdir debian/condor/etc/bash_completion.d


override_dh_auto_clean:
	dh_auto_clean
	# clean up our own mess
	find $(CURDIR) -name '*.class' -delete -o -name '*.jar' -delete
	find . -name '*.pyc' -delete
	# clean leftovers of upstream clean run
	rm -f src/condor_tests/list*
	rm -f src/condor_examples/condor.boot.debian \
		src/condor_examples/condor_config.patched
	rm -f src/condor_tests/Condor.pm src/condor_tests/CondorPersonal.pm \
		src/condor_tests/CondorTest.pm src/condor_tests/CondorUtils.pm \
		src/condor_tests/batch_test.pl \
		src/condor_tests/condor_credmon_oauth_dummy
	rm -f src/condor_utils/param_info.c
	# docs
	$(MAKE) -C docs clean
	rm -rf docs/just-man-pages
	rm -rf docs/_build


override_dh_installdocs:
	dh_installdocs
	for html in `find debian -name "*.html"` ; do \
	    sed -i \
		-e 's#https://maxcdn.bootstrapcdn.com/bootstrap/[^/]*/css/bootstrap.min.css#file:///usr/share/javascript/bootstrap/css/bootstrap.min.css#' \
		-e 's#https://maxcdn.bootstrapcdn.com/bootstrap/.*/js/bootstrap.min.js#file:///usr/share/javascript/bootstrap/js/bootstrap.min.js#' \
		-e 's#[htps:]*//code.jquery.com/jquery-[^/]*\.min\.js#file:///usr/share/javascript/jquery/jquery.min.js#' \
		$${html} ; \
	done

# PDF come in dedicated doc package -- no compression
override_dh_compress:
	dh_compress -X.pdf


override_dh_installinit:
	dh_installinit -pcondor --onlyscripts --noscripts


override_dh_strip:
	dh_strip --dbgsym-migration='condor-dbg (<< 9.3.1~dfsg-1~)'

override_dh_auto_test:

override_dh_gencontrol:
	dh_gencontrol -- \
		-Vlib:Depends="$(foreach package, libscitokens libssl, \
			$(shell dpkg-query -W -f '$${Depends}' $(package)-dev \
				| sed -E 's/.*($(package)[[:alnum:].-]+).*/\1,/' )) \
			$(shell dpkg-query -W -f '$${Depends}' voms-dev \
				| sed -E 's/.*(libvomsapi[[:alnum:].-]+).*/\1,/' )"
